#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=FF.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Firefox Session Save
#AutoIt3Wrapper_Res_Fileversion=1.0.1.0
#AutoIt3Wrapper_Res_LegalCopyright=2012  www.favessoft.com
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_Field=Productname|FFSS
#AutoIt3Wrapper_Res_Field=Productversion|1.01
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; *** Start added by AutoIt3Wrapper ***
#include <Constants.au3>
; *** End added by AutoIt3Wrapper ***
#include <Misc.au3>
#include <MilesAheadMisc.au3>
#include <TrayMenuEx.au3>

Const $ERROR_ALREADY_EXISTS = 183

If _Singleton("{07E112DC-9846-4A43-952A-BA41748A613B}", 1) = 0 Then
	If @error = $ERROR_ALREADY_EXISTS Then Exit
Else
	OnAutoItExitRegister("_Cleanup")
EndIf
AutoItSetOption("TrayMenuMode", 3)
TraySetClick(8)

;flag to prevent windows being open concurrently
Global $windowOpen = False
Global $hotkey = "^+{F10}"
Global $FFsessionList = ""
Global $FFsessionFile = @ScriptDir & "\FFSessionURLs.txt"
TraySetToolTip(_ScriptBaseName())
TrayCreateItem("")
$aboutitem = TrayCreateItem("About")
$downloaditem = TrayCreateItem("Visit Hotkey Page")
;$updateitem = TrayCreateItem("Check for Update")
TrayCreateItem("")
$donateitem = TrayCreateItem("Donate")
TrayCreateItem("")
$exititem = TrayCreateItem("Quit")
TrayItemSetState($aboutitem, $TRAY_DEFAULT)
TraySetToolTip("Firefox Session Save")
If Not HotKeySet($hotkey,"_FFsessionSave") Then
	_ShowError("Could Not assign " & $hotkey & " as the Hotkey : Aborting!")
EndIf

; Tray Message Loop

While 1
	$msg = TrayGetMsg()
	Select
		Case $msg = 0
			; do any polling here
			ContinueLoop

		Case $msg = $aboutitem
			_About()
			_ReduceMemory()

		Case $msg = $downloaditem
			_VisitHotkeyPage()

		Case $msg = $donateitem
			_Donate()

		Case $msg = $exititem
			_Quit()

	EndSelect
WEnd

Func _FFsessionSave()
	$FFsessionList = ""
	Local $clipSave = ClipGet()
	Local $firstURL = "", $thisURL = ""
	Local $ffClass = _WinAPI_GetClassName(_WinAPI_GetForegroundWindow())
	If $ffClass = "MozillaWindowClass" Then ;  _ShowUsage("Yes it is a Mozilla Window : Probably Firefox")
			ClipPut("")
			Send("^l")
			Sleep(10)
			Send("^c")
			Sleep(250)
			$firstURL = ClipGet()
			$FFsessionList &= $firstURL & @CRLF

		Do  ; cycle thorugh tabs getting URLs

			Send("^{Tab}")
			Sleep(100)
			ClipPut("")
			Send("^l")
			Sleep(250)
			Send("^c")
			Sleep(250)
			$thisURL = ClipGet()
			If $firstURL = $thisURL Then ExitLoop
			$FFsessionList &= $thisURL & @CRLF

		Until 0 ; infinite loop

		ClipPut($clipSave)
		If FileExists($FFsessionFile) Then FileDelete($FFsessionFile)
		If FileWrite($FFsessionFile, $FFsessionList) Then
			_ShowUsage("Firefox Session Saved to:" & $FFsessionFile,"",False)
		Else
			_ShowError("Error Writing File: " & $FFsessionFile,"",False)
		EndIf
	EndIf

EndFunc

Func _About()
	Local $about = " Firefox Session Save "
	$about &= FileGetVersion(@ScriptFullPath)
	$about &= "  Copyright (c) " & @YEAR & " www.FavesSoft.com" & @CRLF & @CRLF
	$about &= "Press Hotkey  " & $hotkey & "  to Save FF Session to File"
	_ShowUsage($about,_ScriptBaseName(),False)
EndFunc

Func _VisitHotkeyPage()
	ShellExecute("http://www.favessoft.com/hotkeys.html")
EndFunc   ;==>_VisitHotkeyPage

Func _Donate()
	ShellExecute("http://www.favessoft.com/donate.html")
EndFunc   ;==>_Donate

Func _Quit()
	Exit
EndFunc

; registered clean up function
Func _Cleanup()

EndFunc
